USE TESTDB;

#Update records with a single record 
UPDATE EMPLOYEES
SET LAST_NAME = 'Mirkwood'
WHERE EMP_ID=27;

#Update multiple records
UPDATE EMPLOYEES
SET 
LAST_NAME = 'Firebeams',
BIRTH_DATE = '2785-02-01'
WHERE LAST_NAME IS NULL;

#Update with Replace
UPDATE DEPARTMENTS
SET DEPT_NAME = REPLACE(dept_name,'Rnd','Research and Development')
WHERE DEPT_ID = 5;

SELECT * FROM EMPLOYEES WHERE EMP_ID IN (SELECT EMP_ID FROM EMPLOYEE_DEPT WHERE DEPT_ID =2);

#Update with select subquery
UPDATE EMPLOYEES
SET 
EMAIL = 'support@abc.com'
WHERE EMP_ID IN (SELECT EMP_ID FROM EMPLOYEE_DEPT WHERE DEPT_ID = 2);

#update using the select statement
UPDATE EMPLOYEE_DEPT
SET
DEPT_ID = (SELECT DEPT_ID FROM DEPT_LOCATIONS WHERE LOCATION_NAME = 'Ravenhill')
WHERE RECORD_ID=15;
 
#update with random numbers
#update as 0 rating for all departments that are not 2.
update employees
set rating = 0,
    salary = FLOOR (50000 + RAND() * 130000)
where emp_id in (select emp_id from employee_dept where dept_id <> 2);

#for department =2 , fill in any randome salaries and ratings
update employees
set rating = FLOOR( 1 + RAND( ) * 5 ),
    salary = FLOOR (50000 + RAND() * 130000)
where emp_id in (select emp_id from employee_dept where dept_id =2);


#Update with Inner join
UPDATE EMPLOYEES
        INNER JOIN
    RATINGS ON EMPLOYEES.RATING = RATINGS.RATING_ID 
SET 
    SALARY = ROUND(SALARY + SALARY * PERCENTAGE ,0)
WHERE RATING <> 0;

#Update for Left Join.
UPDATE EMPLOYEES
        LEFT JOIN
    RATINGS ON EMPLOYEES.RATING = RATINGS.RATING_ID 
SET 
    SALARY = ROUND(SALARY + SALARY * 0.40 ,0)
WHERE RATING = 0;
